/* 
 * cGrid.cpp
 * Implementation of the simple grid container.
 */
#include "cGrid.h"
#include "cGridKey.h"
#include "cGridData.h"

cGrid::cGrid()
{
	for(int i = 0; i < NUM_COLS; i++)
	{
		for(int j = 0; j < NUM_ROWS; j++)
		{
			color[i][j] = 0;
			value[i][j] = 0;
		}
	}

}
		
bool cGrid::Insert(Object* key, Object* obj)
{
	int row, col;
	row = ((cGridKey *)key)->GetRow();
	col = ((cGridKey *)key)->GetCol();

	color[row][col] = ((cGridData *)obj)->GetColor();
	value[row][col] = ((cGridData *)obj)->GetValue();
	return true;
}


bool cGrid::MakeObjs(int func, Object** arg1, Object** arg2)
{
	*arg1 = new cGridKey(0, 0);
	*arg2 = new cGridData(0, 0);
	if(!*arg1 || !*arg2)
	{
		return false;
	} 
	else
	{
		return true;
	}
}

OBJ_RETURN cGrid::Marshall(MarshallStream* stream)
{
	for(int i = 0; i < NUM_COLS; i++)
	{
		for(int j = 0; j < NUM_ROWS; j++)
		{
			stream->WriteBytes((char *)&color[i][j], sizeof(int));
			stream->WriteBytes((char *)&value[i][j], sizeof(int));
		}
	}
	return OBJ_RETURN_SUCCESS;
}

OBJ_RETURN cGrid::DeMarshall(DeMarshallStream* stream)
{
	for(int i = 0; i < NUM_COLS; i++)
	{
		for(int j = 0; j < NUM_ROWS; j++)
		{
			stream->ReadBytes((char *)&color[i][j], sizeof(int));
			stream->ReadBytes((char *)&value[i][j], sizeof(int));
		}
	}
	return OBJ_RETURN_SUCCESS;
}


