/* 
 * cGrid.h
 * Class definition for the grid which will be shared among all nodes.
 *
 * Used to provide basic testing of shared containers.
 *
 */

#ifndef __C_GRID_H
#define __C_GRID_H

#define NUM_ROWS	8
#define NUM_COLS	8

#include <stdrw.h> 
#include <cStdCont.h>

class cGrid : public cStdCont
{
	public:
		// constructor
		cGrid();
		~cGrid() { ; }
		
		// define virtual Object functions
		bool Insert(Object* key, Object* obj);
		bool Delete(Object* key) { return false; }

		bool MakeObjs(int func, Object** arg1, Object** arg2);
		OBJ_RETURN Marshall(MarshallStream* stream);
		OBJ_RETURN DeMarshall(DeMarshallStream* stream); 

		// data members
		int color[NUM_ROWS][NUM_COLS];
		int value[NUM_ROWS][NUM_COLS];

	private:
	protected:
};



#endif