/* cGridData.h
 * Class definition for insert key on a grid.
 *
 * Used to provide basic testing of shared containers.
 *
 */

#ifndef __C_GRID_DATA_H
#define __C_GRID_DATA_H

#include <stdrw.h> 
#include <cStdCont.h>

class cGridData : public Object
{
	public:
		// constructor
		cGridData(int value, int color) { mValue = value; mColor = color; }
		~cGridData() { ; }

		// define virtual Object functions
		OBJ_RETURN Marshall(MarshallStream* stream)
		{
			stream->WriteBytes((char *)&mValue, sizeof(int));
			stream->WriteBytes((char *)&mColor, sizeof(int));
			return OBJ_RETURN_SUCCESS;
		}

		OBJ_RETURN DeMarshall(DeMarshallStream* stream)
		{
			stream->ReadBytes((char *)&mValue, sizeof(int));
			stream->ReadBytes((char *)&mColor, sizeof(int));
			return OBJ_RETURN_SUCCESS;
		}
		int	 GetValue() { return mValue; }
		int	 GetColor() { return mColor; }

	private:
		// data members
		int mValue;
		int mColor;

	protected:

};

#endif