/* cGridKey.h
 * Class definition for insert key on a grid.
 *
 * Used to provide basic testing of shared containers.
 *
 */

#ifndef __C_GRID_KEY_H
#define __C_GRID_KEY_H

#include <stdrw.h>
#include <cStdCont.h>

class cGridKey : public Object
{
	public:
		// constructor
		cGridKey(int row, int col) { mRow = row; mCol = col; }

		// define virtual Object functions
		OBJ_RETURN Marshall(MarshallStream* stream)
		{
			stream->WriteBytes((char *)&mRow, sizeof(int));
			stream->WriteBytes((char *)&mCol, sizeof(int));
			return OBJ_RETURN_SUCCESS;
		}

		OBJ_RETURN DeMarshall(DeMarshallStream* stream)
		{
			stream->ReadBytes((char *)&mRow, sizeof(int));
			stream->ReadBytes((char *)&mCol, sizeof(int));
			return OBJ_RETURN_SUCCESS;
		}
		int	 GetRow() { return mRow; }
		int	 GetCol() { return mCol; }

	private:
		// data members
		int mRow;
		int mCol;

	protected:

};


#endif