#ifndef __C_MUTEX_H
#define __C_MUTEX_H
/*
 * cMutex.h
 * 
 * Header for cMutex critical section guard.
 *
 */

#include <windows.h>
#include <winbase.h>

class cMutex
{

 protected:

 public:
		
	// Constructor(s)
	 cMutex() 
	 { 
		mEventHandle = CreateEvent(	NULL,				// pointer to security attributes
									FALSE,				// flag for manual-reset event <auto-reset>
									TRUE,				// flag for initial state <signalled>
									NULL				// pointer to event-object name
									);
	 }
	 cMutex(int initialState)
	 {
		mEventHandle = CreateEvent(	NULL,				// pointer to security attributes
									FALSE,				// flag for manual-reset event <auto-reset>
									initialState,		// flag for initial state <FALSE == not-signaled>
									NULL				// pointer to event-object name
									);		
	 }

	// Destructor
	 ~cMutex() 
	 { 
		CloseHandle(mEventHandle);
	 }

	// Lock
	void	Lock()
	{
		WaitForSingleObject(mEventHandle, INFINITE);
	}
	void	Lock(DWORD timeoutInMilliseconds)	// Lock w/ timeout in milliseconds.
	{
		WaitForSingleObject(mEventHandle, timeoutInMilliseconds);
	}

	// Unlock
	void	Unlock()
	{
		SetEvent(mEventHandle);
	}

 private:
	HANDLE	mEventHandle;
};

#endif