#ifndef __QUEUE_H__
#define __QUEUE_H__

#include "cCriticalSection.h"

// Queue exception class.
class cQueueException { 

 public: 
	cQueueException(char *buf)
	{
		strncpy(mString, buf, 127);
		mString[127] = '\0';
	}
	~cQueueException() { ; }

	char *ToString()
	{
		return mString;
	}
 private:
	char	mString[128];
};

//cFifo class
class cQueue
{

 protected:

 public:
		
	//Constructor(s)
	cQueue(int size);	

	//Destructor
	~cQueue();

	//Public Functions
	bool	Push(void *data);
	bool	Pop(void **data);
	bool	Peek(void **data);		// Peeks at data of next element to remove.
	bool	Clear();				// Clears the queue.
	int		GetNumElements()  { return mNumElements; }
	void	Lock()  { mCS.Enter(); }// Lock this data structure.
	void	Unlock(){ mCS.Leave(); }// Unlocks this data structure.

 private:

	// Mutex
	cCriticalSection	mCS;

	//Member Vars
	void	**mQueue;
	int		  mInsertPtr;
	int		  mRemovePtr;
	int		  mSize;
	int		  mNumElements;
};

#endif
